Bug 848447 - xattr flipping is broken for uid-mapped unprivileged users
xattr flipping is broken for uid-mapped unprivileged users
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: fuse (Show other bugs)
mainline
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Csaba Henk
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-15 12:08 EDT by Csaba Henk
Modified: 2013-07-24 13:58 EDT (History)
2 users (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-24 13:58:02 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Csaba Henk 2012-08-15 12:08:27 EDT
Description of problem:

Xattr flipping is the mechanism we use to circumvent kernel's protection of the "trusted" xattr namespace in the case when we want to give control over some such attrs to unprivileged user (case of unprivileged geo-rep slaves).

For this reason, we treat these attrs addressable also in the "system" namespace (mapped back to trusted before hitting the platter). The unified behavior for system and trusted namespaces is now broken -- in trusted, setxattrs take effect
as one would expect, in system they are just no-ops.

Version-Release number of selected component (if applicable):

From http://review.gluster.com/3687 on.

How reproducible:

Very.

Steps to Reproduce:
1. set up glusterfs, create a volume called, say, "poc"
2. gluster vol set poc indexing on
3. mount poc with this command:
   glusterfs -s localhost --volfile-id=poc --client-pid=-1 /mnt/gluster
4. setfattr -h -n system.glusterfs.whatever.xtime -v something /mnt/gluster
5. getfattr -h -m. -n system.glusterfs.whatever.xtime /mnt/gluster

Actual results:

/mnt/gluster: system.glusterfs.whatever.xtime: No such attribute

Expected results:

# file: mnt/gluster
system.glusterfs.whatever.xtime="something"
Comment 1 Vijay Bellur 2012-08-19 12:31:01 EDT
CHANGE: http://review.gluster.com/3821 (fuse: have setxattr on geo-rep related xattrs take effect) merged in master by Anand Avati (avati@redhat.com)

Note You need to log in before you can comment on or make changes to this bug.